#!/bin/sh

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

# Keep same perms on rc.hald.new:
if [ -e etc/rc.d/rc.hald ]; then
  cp -a etc/rc.d/rc.hald etc/rc.d/rc.hald.new.incoming
  cat etc/rc.d/rc.hald.new > etc/rc.d/rc.hald.new.incoming
  mv etc/rc.d/rc.hald.new.incoming etc/rc.d/rc.hald.new
fi

config etc/rc.d/rc.hald.new
config etc/dbus-1/system.d/hal.conf.new

# If the haldaemon group doesn't exist, add them
if ! grep "^haldaemon:" etc/group >/dev/null 2>&1; then
  echo "haldaemon:x:82:" >>etc/group
fi
if ! grep "^haldaemon:" etc/gshadow >/dev/null 2>&1; then
  echo "haldaemon:!::" >>etc/gshadow
fi

# If the polkituser user doesn't exist, add it
if ! grep "^haldaemon:" etc/passwd >/dev/null 2>&1; then
  echo "haldaemon:x:82:82:User for HAL:/var/run/hald:/bin/false" >>etc/passwd
fi
if ! grep "^haldaemon:" etc/shadow >/dev/null 2>&1; then
  echo "haldaemon:!!:9797:0:::::" >>etc/shadow
fi

#######################
# Link creation code appended by Zenpakt makepkg (version:0.2.0.1)
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/doc/hal-0.5.14/libhal ../../share/gtk-doc/html/libhal ; else
( cd ./usr/doc/hal-0.5.14 ; rm -rf libhal )
( cd ./usr/doc/hal-0.5.14 ; ln -sf ../../share/gtk-doc/html/libhal libhal )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/doc/hal-0.5.14/libhal-storage ../../share/gtk-doc/html/libhal-storage ; else
( cd ./usr/doc/hal-0.5.14 ; rm -rf libhal-storage )
( cd ./usr/doc/hal-0.5.14 ; ln -sf ../../share/gtk-doc/html/libhal-storage libhal-storage )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/lib/libhal.so libhal.so.1.0.0 ; else
( cd ./usr/lib ; rm -rf libhal.so )
( cd ./usr/lib ; ln -sf libhal.so.1.0.0 libhal.so )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/lib/libhal-storage.so libhal-storage.so.1.0.0 ; else
( cd ./usr/lib ; rm -rf libhal-storage.so )
( cd ./usr/lib ; ln -sf libhal-storage.so.1.0.0 libhal-storage.so )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/lib/libhal-storage.so.1 libhal-storage.so.1.0.0 ; else
( cd ./usr/lib ; rm -rf libhal-storage.so.1 )
( cd ./usr/lib ; ln -sf libhal-storage.so.1.0.0 libhal-storage.so.1 )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/lib/libhal.so.1 libhal.so.1.0.0 ; else
( cd ./usr/lib ; rm -rf libhal.so.1 )
( cd ./usr/lib ; ln -sf libhal.so.1.0.0 libhal.so.1 )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/libexec/scripts/linux/hal-system-wol-enable-linux hal-system-wol-linux ; else
( cd ./usr/libexec/scripts/linux ; rm -rf hal-system-wol-enable-linux )
( cd ./usr/libexec/scripts/linux ; ln -sf hal-system-wol-linux hal-system-wol-enable-linux )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/libexec/scripts/linux/hal-system-wol-supported-linux hal-system-wol-linux ; else
( cd ./usr/libexec/scripts/linux ; rm -rf hal-system-wol-supported-linux )
( cd ./usr/libexec/scripts/linux ; ln -sf hal-system-wol-linux hal-system-wol-supported-linux )
fi
if [[ $ZENPAKT_VERSION ]] ;then zenpakt_make_link ./usr/libexec/scripts/linux/hal-system-wol-enabled-linux hal-system-wol-linux ; else
( cd ./usr/libexec/scripts/linux ; rm -rf hal-system-wol-enabled-linux )
( cd ./usr/libexec/scripts/linux ; ln -sf hal-system-wol-linux hal-system-wol-enabled-linux )
fi
#######################
